diff --git a/blockdev.c b/blockdev.c
index 81d1383..2885f2f 100644
--- a/blockdev.c
+++ b/blockdev.c
@@ -2438,6 +2438,124 @@ void qmp_block_job_complete(const char *device, Error **errp)
     block_job_complete(job, errp);
 }
 
+void qmp_change_backing_file(bool has_device, const char *device,
+                             bool has_image, const char *image,
+                             bool has_image_node_name,
+                             const char *image_node_name,
+                             const char *backing_file,
+                             Error **errp)
+{
+    BlockDriverState *bs = NULL;
+    BlockDriverState *image_bs = NULL;
+    Error *local_err = NULL;
+    bool ro;
+    int open_flags;
+    int ret;
+
+    /* validate argument combinations */
+    if (has_image && has_image_node_name) {
+        error_setg(errp, "'image' and 'image-node-name' "
+                         "are mutually exclusive");
+        return;
+    }
+
+    if (has_image && !has_device) {
+        error_setg(errp, "'image' specified, but not 'device'");
+        return;
+    }
+
+    if (!has_image && !has_image_node_name) {
+        error_setg(errp, "either 'image' or 'image-node-name' must be "
+                         "specified");
+        return;
+    }
+
+    /* find the BDS to operate on */
+    if (has_device) {
+        bs = bdrv_find(device);
+        if (!bs) {
+            error_set(errp, QERR_DEVICE_NOT_FOUND, device);
+            return;
+        }
+    }
+
+    if (has_image_node_name) {
+        image_bs = bdrv_lookup_bs(NULL, image_node_name, &local_err);
+        if (local_err) {
+            error_propagate(errp, local_err);
+            return;
+        }
+    }
+
+    if (bs && has_image) {
+        if (!strcmp(bs->filename, image)) {
+            image_bs = bs;
+        } else {
+            image_bs = bdrv_find_backing_image(bs, image);
+        }
+    }
+
+    if (!image_bs) {
+        error_setg(errp, "image file not found");
+        return;
+    }
+
+    bs = bs ?: bdrv_find_active(image_bs);
+    if (!bs) {
+        error_setg(errp, "could not find active layer for '%s'",
+                   image_bs->filename);
+        return;
+    }
+
+    if (bdrv_find_base(image_bs) == image_bs) {
+        error_setg(errp, "not allowing backing file change on an image "
+                         "without a backing file");
+        return;
+    }
+
+    /* even though we are not operating on bs, we need it to
+     * determine if block ops are currently prohibited on the chain */
+    if (bdrv_op_is_blocked(bs, BLOCK_OP_TYPE_CHANGE, errp)) {
+        return;
+    }
+
+    /* final sanity check */
+    if (!bdrv_chain_contains(bs, image_bs)) {
+        error_setg(errp, "'%s' and image file are not in the same chain",
+                   device);
+        return;
+    }
+
+    /* if not r/w, reopen to make r/w */
+    open_flags = image_bs->open_flags;
+    ro = bdrv_is_read_only(image_bs);
+
+    if (ro) {
+        bdrv_reopen(image_bs, open_flags | BDRV_O_RDWR, &local_err);
+        if (local_err) {
+            error_propagate(errp, local_err);
+            return;
+        }
+    }
+
+    ret = bdrv_change_backing_file(image_bs, backing_file,
+                               image_bs->drv ? image_bs->drv->format_name : "");
+
+    if (ret < 0) {
+        error_setg_errno(errp, -ret, "Could not change backing file to '%s'",
+                         backing_file);
+        /* don't exit here, so we can try to restore open flags if
+         * appropriate */
+    }
+
+    if (ro) {
+        bdrv_reopen(image_bs, open_flags, &local_err);
+        if (local_err) {
+            error_propagate(errp, local_err); /* will preserve prior errp */
+        }
+    }
+}
+
 void qmp_blockdev_add(BlockdevOptions *options, Error **errp)
 {
     QmpOutputVisitor *ov = qmp_output_visitor_new();
diff --git a/hmp-commands.hx b/hmp-commands.hx
index 5759252..34a561c 100644
--- a/hmp-commands.hx
+++ b/hmp-commands.hx
@@ -89,6 +89,22 @@ Copy data from a backing file into a block device.
 ETEXI
 
     {
+        .name       = "change_backing_file",
+        .args_type  = "device:s?,image:s?,image_node_name:s?,backing_file:s",
+        .params     = "[device image] [image_node_name] backing_file",
+        .help       = "change the backing file of an image file",
+        .mhandler.cmd = hmp_change_backing_file,
+    },
+
+STEXI
+@item change_backing_file
+@findex change_backing_file
+Chaning the backing file of an image.  This will change the backing
+file metadata in an image file.  You must specify either 'device' and
+'image', or just 'image-node-name'.
+ETEXI
+
+    {
         .name       = "block_job_set_speed",
         .args_type  = "device:B,speed:o",
         .params     = "device speed",
diff --git a/hmp.c b/hmp.c
index 69dd4f5..154b379 100644
--- a/hmp.c
+++ b/hmp.c
@@ -1183,6 +1183,22 @@ void hmp_block_stream(Monitor *mon, const QDict *qdict)
     hmp_handle_error(mon, &error);
 }
 
+void hmp_change_backing_file(Monitor *mon, const QDict *qdict)
+{
+    Error *error = NULL;
+    const char *device          = qdict_get_str(qdict, "device");
+    const char *image           = qdict_get_str(qdict, "image");
+    const char *image_node_name = qdict_get_str(qdict, "image_node_name");
+    const char *backing_file    = qdict_get_str(qdict, "backing_file");
+
+    qmp_change_backing_file(device != NULL, device,
+                            image != NULL, image,
+                            image_node_name != NULL, image_node_name,
+                            backing_file, &error);
+
+    hmp_handle_error(mon, &error);
+}
+
 void hmp_block_job_set_speed(Monitor *mon, const QDict *qdict)
 {
     Error *error = NULL;
diff --git a/hmp.h b/hmp.h
index aba59e9..79b34f4 100644
--- a/hmp.h
+++ b/hmp.h
@@ -70,6 +70,7 @@ void hmp_eject(Monitor *mon, const QDict *qdict);
 void hmp_change(Monitor *mon, const QDict *qdict);
 void hmp_block_set_io_throttle(Monitor *mon, const QDict *qdict);
 void hmp_block_stream(Monitor *mon, const QDict *qdict);
+void hmp_change_backing_file(Monitor *mon, const QDict *qdict);
 void hmp_block_job_set_speed(Monitor *mon, const QDict *qdict);
 void hmp_block_job_cancel(Monitor *mon, const QDict *qdict);
 void hmp_block_job_pause(Monitor *mon, const QDict *qdict);
diff --git a/qapi-schema.json b/qapi-schema.json
index 10be371..ac3fa0b 100644
--- a/qapi-schema.json
+++ b/qapi-schema.json
@@ -2092,6 +2092,63 @@
   'returns': 'str' }
 
 ##
+# @change-backing-file
+#
+# Change the backing file in the image file metadata.  This does not affect
+# the internal data structures of the currently running QEMU instance, but
+# writes changes the backing file string in the image file header metadata.
+#
+# The image file to perform the operation on can be specified by two different
+# methods:
+#
+#  Method 1: Supply the device name (e.g. 'virtio0'), and the image
+#            filename.  This would use arguments @device and @image
+#
+#  Method 2: Supply the node-name of the image to modify, via @image-node-name
+#
+# Either @image or @image-node-name must be set but not both.
+#
+# If @image is specified, @device must be specified as well.
+#
+# Method 1 interface
+#---------------------
+# @device:         #optional The name of the device.  If @image is specified,
+#                            then @device is required.  If @image-node-name is
+#                            specified instead, @device is optional and used to
+#                            validate @image-node-name
+#
+# @image:          #optional The file name of the image to modify
+#
+# Method 2 interface
+#---------------------
+# @image-node-name #optional The name of the block driver state node of the
+#                            image to modify.
+#
+# Common arguments
+#---------------------
+# @backing-file:    The string to write as the backing file.  This string is
+#                   not validated, so care should be taken when specifying
+#                   the string or the image chain may not be able to be
+#                   reopened again.
+#
+#                   If a pathname string is such that it cannot be
+#                   resolved be QEMU, that means that subsequent QMP or
+#                   HMP commands must use node-names for the image in
+#                   question, as filename lookup methods will fail.
+#
+#
+# Returns: Nothing on success
+#          If @device does not exist or cannot be determined, DeviceNotFound
+#          If @image is specified, but not @device, GenericError
+#          If both @image and @image-node-name are specified, GenericError
+#
+# Since: 2.1
+#
+{ 'command': 'change-backing-file',
+  'data': { '*device': 'str', '*image': 'str', '*image-node-name': 'str',
+            'backing-file': 'str' } }
+
+##
 # @block-commit
 #
 # Live commit of data from overlay image nodes into backing nodes - i.e.,
diff --git a/qmp-commands.hx b/qmp-commands.hx
index 837195d..4538c12 100644
--- a/qmp-commands.hx
+++ b/qmp-commands.hx
@@ -1382,6 +1382,76 @@ Example:
 EQMP
 
     {
+        .name       = "change-backing-file",
+        .args_type  = "device:s?,image:s?,image-node-name:s?,backing-file:s",
+        .mhandler.cmd_new = qmp_marshal_input_change_backing_file,
+    },
+
+SQMP
+change-backing-file
+-------------------
+Since: 2.1
+
+Change the backing file in the image file metadata.  This does not affect
+the internal data structures of the currently running QEMU instance, but
+writes changes the backing file string in the image file header metadata.
+
+The image file to perform the operation on can be specified by two different
+methods:
+
+ Method 1: Supply the device name (e.g. 'virtio0'), and the image
+           filename.  This would use arguments "device" and "image"
+
+ Method 2: Supply the node-name of the image to modify, via "image-node-name"
+
+Arguments:
+
+Either "image" or "image-node-name" must be set but not both.
+
+If "image" is specified, "device" must be specified as well.
+
+Method 1 interface
+--------------------
+- "device":             The name of the device.  If "image" is specified,
+                        then "device" is required.  If "image-node-name" is
+                        specified instead, "device" is optional and used to
+                        validate "image-node-name"
+                        (json-string, optional)
+
+- "image":              The file name of the image to modify
+                        (json-string, optional)
+
+
+Method 2 interface
+--------------------
+- "image-node-name":    The name of the block driver state node of the
+                        image to modify.
+                        (json-string, optional)
+
+
+Common arguments
+--------------------
+- "backing-file":       The string to write as the backing file.  This string is
+                        not validated, so care should be taken when specifying
+                        the string or the image chain may not be able to be
+                        reopened again.
+                        (json-string)
+
+                        If a pathname string is such that it cannot be
+                        resolved be QEMU, that means that subsequent QMP or
+                        HMP commands must use node-names for the image in
+                        question, as filename lookup methods will fail.
+
+
+Returns: Nothing on success
+         If "device" does not exist or cannot be determined, DeviceNotFound
+         If "image" is specified, but not "device, GenericError
+         If both "image" and "image-node-name" are specified, GenericError
+
+
+EQMP
+
+    {
         .name       = "balloon",
         .args_type  = "value:M",
         .mhandler.cmd_new = qmp_marshal_input_balloon,